#ifndef __TIMER_CLASS_H__
#define __TIMER_CLASS_H__

#include <windows.h>
#include <MMSystem.h>

#define TMP_TIMER_ARRAY_MAX (3) //ꎞIɗp^C}[̐
enum{
	T_ONE_CICLE = 0,//1TCNɂ鎞(҂Ԃ)
	T_TOTAL_TIME,//V~[^ɏ
	T_SIMULATION,//sim->Simulation()ɔ₷Ԃ̌vp
	T_COMPONENT,//Component()ɔ₷Ԍvp
	T_TRANSMIT,	//Transmitɔ₷Ԍvp
	T_ARRAY_MAX
};

namespace TIMER{

	class SINGLE_TIMER{
		DWORD tmp;
		DWORD total_time; //vl
		DWORD max_time;   //ől
		DWORD min_time;   //ŏl
		DWORD last_data;//ŐV̌v
		int counter;      //
	public:
		void reset(void);
		void setTimer(void){ this->tmp = timeGetTime(); }
		void stopTimer(void);
		void getValue(DWORD *average, DWORD *max, DWORD *min, DWORD *total, DWORD *tmp, DWORD *last_time, int *counter);
		DWORD getValueDiff(void){ return (timeGetTime() - this->tmp); }//ݎtmp̍Ԃ
	};
	
	class TIMER_CLASS{
		SINGLE_TIMER timer[T_ARRAY_MAX + TMP_TIMER_ARRAY_MAX];
	public:
		TIMER_CLASS(){//RXgN^
			timeBeginPeriod( 1 );//x1msɐݒ
			reset(); 
		}
		~TIMER_CLASS(){//fXgN^
			reset();
			timeEndPeriod( 1 );//ύXxɖ߂
		}
		void reset(void);//I[Zbg
		void reset(int timeNum){ this->timer[timeNum].reset(); }//ʃZbg
		void setTimer(int timeNum = T_ARRAY_MAX){ this->timer[timeNum].setTimer(); }
		void stopTimer(int timeNum = T_ARRAY_MAX){ this->timer[timeNum].stopTimer(); }
		void getValue(DWORD *average, DWORD *max, DWORD *min, DWORD *total, DWORD *tmp, DWORD *last_time, int *counter, int timeNum = T_ARRAY_MAX){ this->timer[timeNum].getValue(average, max, min, total, tmp, last_time, counter); }
		DWORD getValueAve(int timeNum = T_ARRAY_MAX);
		DWORD getValueMax(int timeNum = T_ARRAY_MAX);
		DWORD getValueMin(int timeNum = T_ARRAY_MAX);
		DWORD getValueTotal(int timeNum = T_ARRAY_MAX);
		DWORD getValueStart(int timeNum = T_ARRAY_MAX);
		DWORD getValueLastTime(int timeNum = T_ARRAY_MAX);
		int getValueCounter(int timeNum = T_ARRAY_MAX);

		DWORD getValueDiff(int timeNum = T_ARRAY_MAX){ return this->timer[timeNum].getValueDiff(); }
	};

};

#endif