#include <windows.h>
#include <mmsystem.h>

#ifndef ODOMETRY_CALC_CLASS
#define ODOMETRY_CALC_CLASS

namespace ROBOT{
	class POSE{
		double InitX;//ʒux
		double InitY;//ʒuy
		double InitTheta;//px(rad)
		double x;
		double y;
		double theta;
	public:
		//ݒ
		void SetPositionX(double x);
		void SetPositionY(double y);
		void SetTheta(double theta);
		void SetPose(double x, double y, double theta);

		void SetInitPositionX(double x);
		void SetInitPositionY(double y);
		void SetInitTheta(double theta);
		void SetInitPose(double x, double y, double theta);
		
		//擾
		double GetPositionX(void);
		double GetPositionY(void);
		double GetTheta(void);
		void   GetPose(double *x, double *y, double *theta);
		
		double GetInitPositionX(void);
		double GetInitPositionY(void);
		double GetInitTheta(void);
		void   GetInitPose(double *x, double *y, double *theta);
	};

	class VELOCITY{
		double receive_vl;//^Cx̖ڕWl
		double receive_vr;//E^Cx̖ڕWl
		double receive_v;//ڕWix
		double reveive_w;//ڕWpx
		double vr_now;
		double vl_now;
		double v_now;
		double w_now;
	public:
		//ݒ
		void SetVelocityVl(double vl_now);
		void SetVelocityVr(double vr_now);
		void SetVelocity(double vl_now, double vr_now);
		void SetVelocityV(double v);
		void SetVelocityW(double w);

		void SetReceiveVelocityVl(double vl);
		void SetReceiveVelocityVr(double vr);
		void SetReceiveVelocity(double vl, double vr);
		//擾
		double GetVelocityVl(void);
		double GetVelocityVr(void);
		void GetVelocity(double *vl_now, double *vr_now);
		double GetVelocityV(void);
		double GetVelocityW(void);

		double GetReceiveVelocityVl(void);
		double GetReceiveVelocityVr(void);
		void GetReceiveVelocity(double *receive_vl, double *receive_vr);
	};

	class ODOMETRY : public POSE, public VELOCITY{
		double acceleration;// {bgx(mm/sec^2)
		double deceleration;// {bgx(mm/sec^2)
		//double robotMaxVelocity;//{bgő呬x(mm/sec)
		double tread;//ԗփgbh(mm)
		DWORD receive_time;//timeGetTime()Ŏ擾
		double UpdateVelocity(double v_now, double target_v, DWORD delta_time);
		void UpdateState(double average_vl, double average_vr, DWORD delta_time);
		void ConvertVWtoVLVR(double velocity /*(mm/sec)*/, double omega /*(rad/sec)*/);//Mv,wvl,vrɕϊreceive_vl, receive_vrɕۑB
		void ConvertVLVRtoVW(void);//vl_now, vr_nowv,wɕϊv_now, w_nowɕۑB
	public:
		void Reset(DWORD time);//lɃZbg(RtBM[V̒lQlɂB)
		void Update(DWORD time);//IhgXV
		void ControlReceive(double velocity, double omega, DWORD time);//PathPlannerRTCf[^擾ɋNB
		void SetParameter(double tread, double acc, double dec, double InitX, double InitY, double InitTheta);//RtBM[V̒lݒ(InitTheta͓radɕϊ邪Aŗ^̂degreeƂBreceive_time0ɐݒ肷B)
		
	};
}


/* g */

/*

1. SetParameter()ŃRtBM[V̏lݒ肷B
2. Reset()ŊԂɐݒ肷B

3.
  -l󂯎AControlReceive֐NB
  -IhgZƂAUpdate֐NB

4. PathPlannerstatevelocity𑗂ƂAGetPose()֐GetVelocityNB(钼OUpdate֐N悢ƎvB)

*/
#endif