#include "TIMER_CLASS.h"

void TIMER::SINGLE_TIMER::stopTimer(void){
	this->last_data = getValueDiff();
	if(this->last_data > this->max_time) this->max_time = this->last_data;
	if((counter == 0) || (this->last_data < this->min_time)) this->min_time = this->last_data;
	this->total_time += this->last_data;
	this->counter++;
}

void TIMER::SINGLE_TIMER::reset(void){
	this->counter = 0;
	this->tmp = 0;
	this->total_time = 0;
	this->max_time = 0;
	this->min_time = 0;
	this->last_data = 0;
}

void TIMER::SINGLE_TIMER::getValue(DWORD *average, DWORD *max, DWORD *min, DWORD *total, DWORD *tmp, DWORD *last_time, int *counter){
	if(average != NULL){
		if(this->counter == 0){
			*average = 0;
		}else{
			*average = total_time / this->counter;
		}
	}
	if(max != NULL){
		*max = max_time;
	}
	if(min != NULL){
		*min = min_time;
	}
	if(total != NULL){
		*total = total_time;
	}
	if(tmp != NULL){
		*tmp = this->tmp;
	}
	if(last_time != NULL){
		*last_time = this->last_data;
	}
	if(counter != NULL){
		*counter = this->counter;
	}
}

void TIMER::TIMER_CLASS::reset(){//I[Zbg
	for(int i=0;i<T_ARRAY_MAX + TMP_TIMER_ARRAY_MAX;i++){
		this->reset(i);//ʃZbg
	}
}

DWORD TIMER::TIMER_CLASS::getValueAve(int timeNum){
	DWORD tmp;
	getValue(&tmp, NULL, NULL, NULL, NULL, NULL, NULL, timeNum);
	return tmp;
}
DWORD TIMER::TIMER_CLASS::getValueMax(int timeNum){
	DWORD tmp;
	getValue(NULL, &tmp, NULL, NULL, NULL, NULL, NULL, timeNum);
	return tmp;
}
DWORD TIMER::TIMER_CLASS::getValueMin(int timeNum){
	DWORD tmp;
	getValue(NULL, NULL, &tmp, NULL, NULL, NULL, NULL, timeNum);
	return tmp;
}
DWORD TIMER::TIMER_CLASS::getValueTotal(int timeNum){
	DWORD tmp;
	getValue(NULL, NULL, NULL, &tmp, NULL, NULL, NULL, timeNum);
	return tmp;
}
DWORD TIMER::TIMER_CLASS::getValueStart(int timeNum){
	DWORD tmp;
	getValue(NULL, NULL, NULL, NULL, &tmp, NULL, NULL, timeNum);
	return tmp;
}
DWORD TIMER::TIMER_CLASS::getValueLastTime(int timeNum){
	DWORD tmp;
	getValue(NULL, NULL, NULL, NULL, NULL, &tmp, NULL, timeNum);
	return tmp;
}
int TIMER::TIMER_CLASS::getValueCounter(int timeNum){
	int tmp;
	getValue(NULL, NULL, NULL, NULL, NULL, NULL, &tmp, timeNum);
	return tmp;
}