//------------------------------------------------------------------------------------------------+
// Filename: RangeSensor.h
// Content : ZTV~[^ōČ邽߂̃NX
//------------------------------------------------------------------------------------------------+

#ifndef RANGESENSOR
#define RANGESENSOR

#include "Simulator/People.h"
#include "Simulator/Field.h"
#include <vector>

using namespace std;


//------------------------------------------------------------------------------------------------+
// ZTNX
//------------------------------------------------------------------------------------------------+
class RangeSensor{
public:
	double start_position;
	double end_position;
	double max_distance;
	long   far_code;
	int    data_num;
	double sensor_x;		// {bgƂ̑΍W
	double sensor_y;		// {bgƂ̑΍W
	double sensor_heading;	// {bgƂ̑΍W
	double std_dev;			// vɗ^덷̕W΍

	vector<long> range_data;
	Lines rays;

	RangeSensor(){ sensor_x = sensor_y = 0.0; }
	RangeSensor( double start_pos, double end_pos, double max_dist, long far_code, int data_num, double x=0.0, double y=0.0, double heading=0.0, double std_dev=0.0 );
	double DataInterval();
	void Sensing( Robot *robo, Walls *walls, People *people, double peason_radius );
	void Sensing( int no, Line ray, Walls *walls );
	void Sensing( int no, Line ray, People *people, double peason_radius );
};


#endif // RANGESENSOR
