//------------------------------------------------------------------------------------------------+
// Filename: Factory.h
// Content : t@NgNXƃt@Ng֘ANX̒`
//------------------------------------------------------------------------------------------------+
#ifndef __FACTORY
#define __FACTORY

#include "Field.h"
#include "People.h"
#include "Network.h"
#include <vector>
#include <list>

using namespace std;


//------------------------------------------------------------------------------------------------+
// t@C̋Lq͂ăg[NɕNX̒`
//------------------------------------------------------------------------------------------------+
class TokenAnalysis{
public:
	// t@Cǂݍ݂̂߂̃g[Ñf[^^Ȃǂ`
	enum TokenType{
		T_ARC_LEFT,
		T_ARC_RIGHT,
		T_NUMBER,
		T_STRING,
		T_CORON,
		T_SEMICORON
	};

	union TokenNum{
		double d;
		char str[256];
	};

	typedef struct Token_{

		TokenType type;
		TokenNum num;

	} Token;

	list<Token> token_list;
	TokenAnalysis( const char *filename );
	bool ReadNumber( list<TokenNum>& num_list );	// u;v܂Œlǂň̃XgɈڂ

private:
	bool PushNumToken( Token tok );		// lłg[No^
};


//------------------------------------------------------------------------------------------------+
// tB[h\zNX̒`
//------------------------------------------------------------------------------------------------+
class FieldFactory{

	class AreaLink{
	public:
		int id1, id2;
		Line line;
		AreaLink( int id1, int id2, Line line ){
			this->id1  = id1;
			this->id2  = id2;
			this->line = line;
		}
	};
	std::list<AreaLink> links;

public:
	Field     field;
	ActionMng act_mng;
	SubAreas subareas;

	FieldFactory( const char *filename );	// RXgN^

private:
	TokenAnalysis *token;

	bool NewDataCreate();			// g[Nevfo^
	bool NewWall();					// g[Nǃf[^o^
	bool NewEntrance();				// g[Nf[^o^
	bool NewDestination();			// g[NړInf[^o^
	bool NewAction();				// g[Nsf[^o^
	bool NewFirstActions();			// g[Nŏ̍sf[^o^
	bool NewSubArea();				// g[NTuGAf[^o^
	bool NewAreaLink();				// g[NTuGÃNf[^𐶐
	void RegistAreaLink();			// TuGÃNf[^TuGAɓo^
};


#endif	//__FACTORY
